"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const template_processor_1 = require("template-processor");
const HTMLElement_class_1 = require("./HTMLElement.class");
class xjs_HTMLTableSectionElement extends HTMLElement_class_1.default {
    constructor(node) {
        super(node);
    }
    get node() { return super.node; }
    populate(instructions, dataset, options, this_arg = this) {
        let template = this.node.querySelector('template');
        if (template === null) {
            throw new ReferenceError('This <thead/tfoot/tbody> does not have a <template> descendant.');
        }
        if (template.content.children.length !== 1 || !template.content.children[0].matches('tr')) {
            throw new ReferenceError('The <template> must contain exactly 1 element, which must be a <tr>.');
        }
        let processor = new template_processor_1.Processor(template, instructions);
        return this.append(...dataset.map((data) => processor.process(data, options, this_arg)));
    }
}
exports.default = xjs_HTMLTableSectionElement;
