"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const template_processor_1 = require("template-processor");
const HTMLElement_class_1 = require("./HTMLElement.class");
const HTMLTemplateElement_class_1 = require("./HTMLTemplateElement.class");
class xjs_HTMLUListElement extends HTMLElement_class_1.default {
    static async template() {
        return HTMLTemplateElement_class_1.default.fromFile(path.join(__dirname, '../../src/tpl/x-htmlulistelement.tpl.html'));
    }
    static templateSync() {
        return HTMLTemplateElement_class_1.default.fromFileSync(path.join(__dirname, '../../src/tpl/x-htmlulistelement.tpl.html'));
    }
    constructor(node) {
        super(node);
    }
    get node() { return super.node; }
    populate(instructions, dataset, options, this_arg = this) {
        let template = this.node.querySelector('template');
        if (template === null) {
            throw new ReferenceError('This <ul> does not have a <template> descendant.');
        }
        if (template.content.children.length !== 1 || !template.content.children[0].matches('li')) {
            throw new ReferenceError('The <template> must contain exactly 1 element, which must be an <li>.');
        }
        let processor = new template_processor_1.Processor(template, instructions);
        return this.append(...dataset.map((data) => processor.process(data, options, this_arg)));
    }
}
exports.default = xjs_HTMLUListElement;
